Subject: Routing: Routes should ignore query parameters if not configured
Description

Currently a route behaves weird if a query is given but not configured. Consider this example:

$c->TYPO3Route_ServiceWithControllerAndFormat
    ->setUrlPattern('typo3/service/v1/[@controller].[@format]')
    ->setControllerComponentNamePattern('F3::@package::Service::Controller::@controllerController')
    ->setViewComponentNamePattern('F3::@package::Service::View::@controller::@action@format')
    ->setDefaults(
        array(
            '@package' => 'TYPO3',
        )
    );

Now calling the URLs as following results in...

http://site/typo3/service/v1/sites.json
 => correct output
http://site/typo3/service/v1/sites.json?something
 => An invalid request format (json?something) was given.

Not good. Trying to add ? to the end:

$c->TYPO3Route_ServiceWithControllerAndFormat
    ->setUrlPattern('typo3/service/v1/[@controller].[@format]?')

Still the same results.

Workaround: add "?[@dummy]" to the pattern, and it works.

$c->TYPO3Route_ServiceWithControllerAndFormat
    ->setUrlPattern('typo3/service/v1/[@controller].[@format]?[@dummy]')

Expected solution:
    -  ignore a query if not needed
http://site/typo3/service/v1/sites.json
http://site/typo3/service/v1/sites.json?something


Associated revisions
Revision 7c04992d - 2008-10-30 13:46 - Bastian Waidelich

    -  FLOW3: (MVC) Changed handling of Query parameters in URIs. They are ignored now, unless explicitly configured in URI pattern. This fixes
#1635. Note: if you want to access a query parameter, you still have to add it to your route.
    -  FLOW3: (MVC) Some smaller tweaks and fixes in Route class.

History
#1 - 2008-10-11 11:19 - Bastian Waidelich

Todo: When a query string is given in the UriPattern, this should be matched exactly. If not, query strings are ignored.

#2 - 2008-10-23 10:41 - Bastian Waidelich
- Target version set to 1.0 alpha 1

#3 - 2008-10-23 10:43 - Bastian Waidelich
- Subject changed from Routes should ignore query parameters if not configured to Routing: Routes should ignore query parameters if not configured

#4 - 2008-10-28 12:53 - Karsten Dambekalns
- Target version deleted (1.0 alpha 1)

#5 - 2008-10-28 12:58 - Karsten Dambekalns
- Target version set to 1.0 alpha 1

#6 - 2008-10-30 13:50 - Bastian Waidelich
- Status changed from New to Resolved
- % Done changed from 0 to 100

Applied in changeset r1408.

#7 - 2008-12-19 11:09 - Bastian Waidelich

NOTE Behavior of queries in Routes will change:
Query strings won't be part of the URI patterns anymore to avoid complexity of configuration and implementation.
Instead, query strings will be ignored when matching routes. All query parameters will be passed through to the current request object.
When building URIs, remaining Route values will be added to the query string in the format:

?key1=value1&key2=value2
